TYPE FastStr = STRING[255];

CONST InversStartAdres = $A00;

VAR PatternNamePage  : BYTE;
    PatternGenPage   : BYTE;
    Lines26Half      : BYTE;

    SchermBuffer     : ARRAY [0..2047] OF BYTE;
    LastMenuVDPPage  : BYTE;
    LastMenuVDPAdres : INTEGER;

PROCEDURE Read_VDPInl;
BEGIN
  INLINE($DD/$21/$F3DF/$FE/$08/$38/$06/$DD/$21/$FFE7/$D6/$08/
         $32/*+4/$DD/$7E/$00)
END;

FUNCTION Read_VDP(num : BYTE) : BYTE;
BEGIN
  INLINE($3A/num/$CD/Read_VDPInl/$6F/$26/$00/$C9)
END;

PROCEDURE Write_VDPInl;
BEGIN
  INLINE($F3/$F5/$D3/$99/$78/$F6/$80/$D3/$99/$E6/$7F/$DD/$21/$F3DF/$FE/
         $08/$38/$06/$DD/$21/$FFE7/$D6/$08/$32/*+5/$F1/$DD/$77/$00/$FB)
END;

PROCEDURE Write_VDP(num,data : BYTE);
BEGIN
  INLINE($3A/num/$47/$3A/data/$CD/Write_VDPInl)
END;

PROCEDURE Init_VPoke;
BEGIN
  INLINE($7C/$17/$17/$17/$E6/$07/$F3/$D3/$99/$3E/142/$D3/$99/
         $7D/$D3/$99/$7C/$E6/$3F/$F6/$40/$D3/$99)
END;

PROCEDURE Init_VPeek;
BEGIN
  INLINE($7C/$17/$17/$17/$E6/$07/$F3/$D3/$99/$3E/142/
         $D3/$99/$7D/$D3/$99/$7C/$E6/$3F/$D3/$99)
END;

PROCEDURE Maal80Inl;
BEGIN
  INLINE($29/$29/$29/$29/$E5/$29/$29/$D1/$19)
END;

PROCEDURE CalcPageAdres;
BEGIN
  INLINE($E6/$1F/$07/$07/$07/$17/$67/$2E/$00/$17)
END;

PROCEDURE CalcPatternAdres;
BEGIN
  INLINE($E6/$3F/$67/$2E/$00/$AF/$29/$29/$29/$17)
END;

PROCEDURE Screen0Page(num : BYTE);
BEGIN
  INLINE($3A/num/$E6/$1F/$32/PatternNamePage/$07/$07/$F6/$03/
         $06/$02/$CD/Write_VDPInl/$3A/num/$FE/$04/$D0/$07/
         $07/$07/$07/$67/$2E/$00/$22/$22/$F9)
END;

PROCEDURE Screen0Patterns(num : BYTE);
BEGIN
  INLINE($3A/num/$E6/$3F/$32/PatternGenPage/$06/$04/$CD/Write_VDPInl)
END;

PROCEDURE ChangePatterns(kset,num,aantal : BYTE; adres : INTEGER);
BEGIN
  INLINE($3A/num/$6F/$26/$00/$29/$29/$29/$EB/$3A/kset/$CD/CalcPatternAdres/
         $19/$1F/$CD/Init_VPoke/$2A/adres/$3A/aantal/$01/$98/$08/$ED/$B3/
         $3D/$20/$F8/$FB)
END;

PROCEDURE GetPatterns(kset,num,aantal : BYTE; adres : INTEGER);
BEGIN
  INLINE($3A/num/$6F/$26/$00/$29/$29/$29/$EB/$3A/kset/$CD/CalcPatternAdres/
         $19/$1F/$CD/Init_VPeek/$2A/adres/$3A/aantal/$01/$98/$08/$ED/$B2/
         $3D/$20/$F8/$FB)
END;

PROCEDURE Clear_Screen(num : BYTE);
BEGIN
  INLINE($3A/num/$CD/CalcPageAdres/$1F/$CD/Init_VPoke/$01/$07/$00/$3E/32/
         $D3/$98/$10/$FC/$0D/$20/$F9/$06/$80/$D3/$98/$10/$FC/$3A/Lines26Half/
         $B7/$28/$08/$3E/32/$06/240/$D3/$98/$10/$FC/$FB)
END;

PROCEDURE Fast_Str(x,y,page : BYTE; st : FastStr);
BEGIN
  INLINE($3A/y/$6F/$26/$00/$CD/Maal80Inl/$3A/x/$5F/$16/$00/$19/$EB/$3A/page/
         $CD/CalcPageAdres/$19/$1F/$CD/Init_VPoke/$21/st/$46/$23/$0E/$98/
         $ED/$B3/$FB)
END;

PROCEDURE InitVDPStack(adres : INTEGER; page : BYTE);
BEGIN
  Lines26Half     :=Read_VDP(9) AND $80;
  LastMenuVDPAdres:=adres;
  LastMenuVDPPage :=page AND 1
END;

PROCEDURE Lines27;
BEGIN
  INLINE($3E/$09/$CD/Read_VDPInl/$F6/$80/$06/$09/$CD/Write_VDPInl/$3E/$80/
         $32/Lines26Half/$3E/27/$32/$F3B1)
END;

PROCEDURE Lines24;
BEGIN
  INLINE($3E/$09/$CD/Read_VDPInl/$E6/$7F/$06/$09/$CD/Write_VDPInl/
         $AF/$32/Lines26Half/$3E/24/$32/$F3B1)
END;

PROCEDURE CursorBack;
BEGIN
  INLINE($3A/$F3DC/$6F/$26/$00/$CD/Maal80Inl/$3A/$F3DD/$5F/$16/$00/
         $19/$11/81/$00/$B7/$ED/$52/$ED/$5B/$22/$F9/$19/$B7/$CD/Init_VPeek/
         $DB/$98/$FE/$FF/$C8/$32/$CC/$FB);
  GOTOXY(MEM[$F3DD],MEM[$F3DC])
END;

PROCEDURE WriteVDPBytes(aantal : INTEGER);
BEGIN
  INLINE($2A/LastMenuVDPAdres/$3A/LastMenuVDPPage/$1F/$CD/Init_VPoke/
         $21/SchermBuffer/$01/$98/$00/$ED/$5B/aantal/$AF/$B2/$28/$05/
         $ED/$B3/$15/$18/$F7/$7B/$B7/$28/$03/$47/$ED/$B3/$FB/
         $2A/LastMenuVDPAdres/$ED/$5B/aantal/$19/$22/LastMenuVDPAdres/
         $3A/LastMenuVDPPage/$CE/$00/$32/LastMenuVDPPage)
END;

PROCEDURE ReadVDPBytes(aantal : INTEGER);
BEGIN
  INLINE($2A/LastMenuVDPAdres/$3A/LastMenuVDPPage/$ED/$5B/aantal/$B7/
         $ED/$52/$DE/$00/$32/LastMenuVDPPage/$22/LastMenuVDPAdres/$1F/
         $CD/Init_VPeek/$21/SchermBuffer/$01/$98/$00/$AF/$B2/$28/$05/
         $ED/$B2/$15/$18/$F7/$7B/$B7/$28/$03/$47/$ED/$B2/$FB)
END;

PROCEDURE SaveScreen(x1,y1,x2,y2,page : BYTE);
VAR breed,hoog : BYTE;
    start      : INTEGER;
BEGIN
  breed:=SUCC(x2-x1);
  hoog :=SUCC(y2-y1);
  INLINE($3A/y1/$6F/$26/$00/$CD/Maal80Inl/$3A/x1/$5F/$16/$00/$19/$22/start/
         $EB/$21/SchermBuffer/$73/$23/$72/$23/$3A/hoog/$5F/$77/$23/
         $3A/breed/$57/$77/$23/$0E/$98/$D9/$3A/page/$CD/CalcPageAdres/
         $ED/$5B/start/$19/$11/80/$00/$D9/$1F/$D9/$F5/$CD/Init_VPeek/
         $19/$D9/$42/$ED/$B2/$FB/$F1/$1D/$20/$F1/$11/SchermBuffer/
         $B7/$ED/$52/$22/start);
  WriteVDPBytes(start);
  INLINE($21/InversStartAdres/$B7/$CD/Init_VPeek/$01/$98/250/
         $21/SchermBuffer/$ED/$B2/$06/20/$ED/$B2/$FB);
  WriteVDPBytes(270);
  start:=start+270;
  SchermBuffer[0]:=LO(start);
  SchermBuffer[1]:=HI(start);
  WriteVDPBytes(2)
END;

PROCEDURE RestoreScreen(page : BYTE);
VAR oud  : REAL;
    size : INTEGER;
BEGIN
  ReadVDPBytes(2);
  size:=SchermBuffer[1]*256+SchermBuffer[0];
  ReadVDPBytes(270);
  INLINE($21/InversStartAdres/$B7/$CD/Init_VPoke/$01/$98/250/
         $21/SchermBuffer/$ED/$B3/$06/20/$ED/$B3/$FB);
  ReadVDPBytes(size-270);
  INLINE($21/SchermBuffer/$5E/$23/$56/$23/$D5/$D9/$3A/page/
         $CD/CalcPageAdres/$D1/$19/$11/80/$00/$D9/$5E/$23/$56/$23/$0E/$98/
         $1F/$D9/$F5/$CD/Init_VPoke/$19/$D9/$42/$ED/$B3/$FB/$F1/$1D/$20/$F1)
END;

